## cantata 2.3.0.ds1

=== CMakeLists.txt ===
PROJECT(cantata)

#  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, and README will need updating.
#        dbus/mpd.cantata.xml and devices/mounter/mpd.cantata.mounter.xml will also need renaming/updating.
set(PROJECT_URL "cantata.mpd")
set(PROJECT_REV_URL "mpd.cantata")

if (CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    set(OPENBSD TRUE)
endif ()

if (WIN32)
    # For some reason I chose mpd as the organization name for Windows builds. So, for config compatability, this is
    # left as mpd for now...
    set(ORGANIZATION_NAME "mpd")
else ()
    # Otherwise its set to the same as the project name. Not sure what else to set it to!!!
    set(ORGANIZATION_NAME ${CMAKE_PROJECT_NAME})
endif ()

cmake_minimum_required(VERSION 2.6)
cmake_policy(SET CMP0020 OLD)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_GENERATOR "DEB;RPM;TBZ2")
set(DEBIAN_PACKAGE_DESCRIPTION "Qt Client for MPD")
set(CPACK_SOURCE_GENERATOR "TBZ2")
set(CPACK_PACKAGE_VERSION_MAJOR "2")
set(CPACK_PACKAGE_VERSION_MINOR "3")
set(CPACK_PACKAGE_VERSION_PATCH "0")
set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
set(CANTATA_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
set(CANTATA_VERSION_FULL "${CANTATA_VERSION}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CANTATA_VERSION_WITH_SPIN "${CANTATA_VERSION_FULL}${CPACK_PACKAGE_VERSION_SPIN}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
set(CPACK_SOURCE_IGNORE_FILES  "/.svn/;/.git/;.gitignore;.project;CMakeLists.txt.user;README.md;/screenshots/")
include(CPack)
include(MacroLogFeature)

option(ENABLE_TAGLIB "Enable TagLib library (required for tag editing, replaygain calculation, device support, etc)" ON)
option(ENABLE_HTTP_STREAM_PLAYBACK "Enable playback of MPD HTTP streams (LibVLC or QtMultimedia)" ON)
option(ENABLE_FFMPEG "Enable ffmpeg/libav libraries (required for replaygain calculation)" ON)
option(ENABLE_MPG123 "Enable mpg123 libraries (required for replaygain calculation)" ON)
option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" OFF)
option(ENABLE_HTTP_SERVER "Enable internal HTTP server to play non-MPD files" ON)
if (WIN32 OR APPLE OR HAIKU)
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
    option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
else ()
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
    option(ENABLE_REMOTE_DEVICES "Enable support for remote (sshfs, samba) devices" ON)
    option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" ON)
    option(ENABLE_SIMPLE_MPD_SUPPORT "Enable support for simple (Cantata controlled) MPD" ON)
    option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" ON)
endif ()
option(ENABLE_CDPARANOIA "Enable CDParanoia libraries (this or libCDIO_paranoia required for AudioCD support)" ON)
option(ENABLE_CDIOPARANOIA "Enable libCDIO_paranoia libraries (this or CDParanoia required for AudioCD support)" ON)
option(ENABLE_CDDB "Enable CDDB libraries (either this or MusicBrianz required for AudioCD support)" ON)
option(ENABLE_MUSICBRAINZ "Enable MusicBrianz libraries (either this or CDDB required for AudioCD support)" ON)
option(ENABLE_MTP "Enable MTP library (required to support MTP devices)" ON)
option(ENABLE_AVAHI "Enable automatic mpd server discovery" ${UNIX})

if(ENABLE_AVAHI)
    find_package(Avahi)
    macro_log_feature(AVAHI_FOUND "Avahi Support" "Automatic MPD-Server Detection" "https://www.avahi.org/" FALSE "" "")
endif()

if (AVAHI_FOUND)
    set(CANTATA_SRCS ${CANTATA_SRCS} gui/findmpddialog.cpp gui/avahidiscovery.cpp gui/avahipoll.cpp)
    set(CANTATA_UIS ${CANTATA_UIS} gui/findmpddialog.ui)

    set(CANTATA_LIBS ${CANTATA_LIBS} ${AVAHI_LIBRARIES})
endif()

if (NOT APPLE AND NOT WIN32 AND NOT HAIKU)
    set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share"
        CACHE PATH "Define install directory for read-only architecture-independent data")
else ()
    set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"
        CACHE PATH "Define install directory for read-only architecture-independent data")
endif ()

if (WIN32)
    set(CANTATA_ICON_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/icons/cantata)
elseif (APPLE)
    set(MACOSX_BUNDLE_BUNDLE_NAME Cantata)
    set(MACOSX_BUNDLE_EXECUTABLE cantata)
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CANTATA_VERSION})
    set(MACOSX_BUNDLE_VERSION ${CANTATA_VERSION})
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${CANTATA_VERSION_WITH_SPIN})
    set(MACOSX_BUNDLE_ICON_FILE cantata.icns)
    set(CANTATA_APP_CONTENTS_DIR ${CMAKE_INSTALL_PREFIX}/Cantata.app/Contents)
    set(MACOSX_BUNDLE_RESOURCES ${CANTATA_APP_CONTENTS_DIR}/Resources)
    set(MACOSX_BUNDLE_APP_DIR ${CANTATA_APP_CONTENTS_DIR}/MacOS)
    set(CANTATA_ICON_INSTALL_PREFIX ${MACOSX_BUNDLE_RESOURCES}/icons/cantata)
elseif (NOT HAIKU)
    set(CANTATA_ICON_INSTALL_PREFIX ${SHARE_INSTALL_PREFIX}/icons/hicolor)
endif ()

if (NOT WIN32 AND NOT APPLE AND ENABLE_DEVICES_SUPPORT AND ENABLE_UDISKS2)
    set(WITH_SOLID_UDISKS2 ON)
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message("-- Set build type to ${CMAKE_BUILD_TYPE}")
endif ()

if (NOT APPLE AND NOT WIN32)
    if (CANTATA_HELPERS_LIB_DIR AND CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(LINUX_LIB_DIR ${CANTATA_HELPERS_LIB_DIR})
    else ()
        set(LINUX_LIB_DIR lib)
    endif ()
endif ()


if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT APPLE AND NOT WIN32 AND NOT HAIKU)
    set(CMAKE_INSTALL_PREFIX "/usr")
    message("-- Set install prefix to ${CMAKE_INSTALL_PREFIX}")
endif ()

if (ENABLE_TAGLIB)
    if (NOT TAGLIB_FOUND)
        set(TAGLIB_MIN_VERSION "1.6")
        find_package(Taglib)
    endif()
    macro_log_feature(TAGLIB_FOUND "TagLib" "Tag editor, file organiser, etc." "http://taglib.github.io/")
endif ()

if (TAGLIB_FOUND)
    if (ENABLE_DEVICES_SUPPORT AND (ENABLE_CDIOPARANOIA OR ENABLE_CDPARANOIA))
        # Issue 1021 - prefer libcdio_paranoia over plain cdparanoia
        if (ENABLE_CDIOPARANOIA)
            find_package(Cdioparanoia)
            macro_log_feature(CDIOPARANOIA_FOUND "libcdio_paranoia" "CD ripping." "https://www.gnu.org/software/libcdio/")
        endif()
        if (NOT CDIOPARANOIA_FOUND)
            find_package(Cdparanoia)
            macro_log_feature(CDPARANOIA_FOUND "libcdda_paranoia" "CD ripping." "http://www.xiph.org/paranoia")
        endif()
        if (CDIOPARANOIA_FOUND OR CDPARANOIA_FOUND)
            if (ENABLE_CDDB)
                find_package(CDDB)
                macro_log_feature(CDDB_FOUND "libcddb" "CD info retrieval via CDDB." "http://libcddb.sourceforge.net")
            endif ()
            if (ENABLE_MUSICBRAINZ)
                find_package(MusicBrainz5)
                macro_log_feature(MUSICBRAINZ5_FOUND "libmusicbrainz5" "CD info retrieval via MusicBrainz." "http://musicbrainz.org/doc/libmusicbrainz")
            endif ()
        endif ()
    endif ()

    set(ENABLE_TAGEDITOR_SUPPORT 1)
    set(ENABLE_TRACKORGANIZER_SUPPORT 1)
    include(CheckCXXSourceCompiles)
    set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
    set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

    check_cxx_source_compiles("#include <asftag.h>
                            int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
    if (NOT TAGLIB_ASF_FOUND)
        message("TagLib does not have ASF support compiled in.")
    endif ()

    check_cxx_source_compiles("#include <mp4tag.h>
                            int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
    if (NOT TAGLIB_MP4_FOUND)
        message("TagLib does not have MP4 support compiled in.")
    endif ()

    check_cxx_source_compiles("#include <opusfile.h>
                            int main() { TagLib::Ogg::Opus::File *f=0; return 0;}" TAGLIB_OPUS_FOUND)
    if (NOT TAGLIB_OPUS_FOUND)
        message("TagLib does not have OPUS support compiled in.")
    endif ()

    set(CMAKE_REQUIRED_INCLUDES)
    set(CMAKE_REQUIRED_LIBRARIES)

    #include(CheckTagLibFileName)
    #check_taglib_filename(COMPLEX_TAGLIB_FILENAME)

    add_definitions(${TAGLIB_CFLAGS})

    if (ENABLE_FFMPEG)
        find_package(FFMPEG)
        macro_log_feature(FFMPEG_FOUND "libavcodec/libavutil/libavformat" "ReplayGain calculation." "http://ffmpeg.org")
    endif ()
    if (ENABLE_MPG123)
        find_package(MPG123)
        macro_log_feature(MPG123_FOUND "libmpg123" "ReplayGain calculation." "http://www.mpg123.de")
    endif ()
    if (ENABLE_MTP AND ENABLE_DEVICES_SUPPORT AND NOT WIN32 AND NOT APPLE)
        find_package(Mtp)
        macro_log_feature(MTP_FOUND "libmtp" "MTP Device Support." "http://libmtp.sourceforge.net")
    endif ()
else (TAGLIB_FOUND)
   set(ENABLE_DEVICES_SUPPORT OFF)
endif ()

if (NOT MTP_FOUND)
   set(ENABLE_UNCACHED_MTP OFF)
endif ()

find_package(Qt5Widgets REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Sql REQUIRED)

set(CMAKE_AUTOMOC TRUE)
set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_STANDARD 11)

set(QTCORELIBS ${Qt5Core_LIBRARIES})
set(QTNETWORKLIBS ${Qt5Network_LIBRARIES})
set(QTGUILIBS ${Qt5Gui_LIBRARIES})
set(QTLIBS ${QTCORELIBS} ${Qt5Widgets_LIBRARIES} ${QTNETWORKLIBS} ${QTGUILIBS} ${Qt5Xml_LIBRARIES} ${Qt5Concurrent_LIBRARIES} ${Qt5Svg_LIBRARIES} ${Qt5Sql_LIBRARIES})
set(QTINCLUDES ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Concurrent_INCLUDE_DIRS}
    ${Qt5Svg_INCLUDE_DIRS} ${Qt5Sql_INCLUDE_DIRS})
add_definitions(${Qt5Widgets_DEFINITIONS} ${Qt5Network_DEFINITIONS} ${Qt5Xml_DEFINITIONS} ${Qt5Concurrent_DEFINITIONS} ${Qt5Svg_DEFINITIONS} ${Qt5Sql_DEFINITIONS})
if (Qt5_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
endif ()

if (APPLE OR WIN32 OR HAIKU)
    get_target_property(QT_QMAKE_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
    exec_program(${QT_QMAKE_EXECUTABLE} ARGS -query QT_INSTALL_TRANSLATIONS OUTPUT_VARIABLE QT_TRANSLATIONS_DIR)
else ()
    find_package(Qt5DBus REQUIRED)
    set(QT_QTDBUS_FOUND 1) # required for config.h !!!
    set(QTLIBS ${QTLIBS} ${Qt5DBus_LIBRARIES})
    set(QTINCLUDES ${QTINCLUDES} ${Qt5DBus_INCLUDE_DIRS})
    add_definitions(${Qt5DBus_DEFINITIONS})
endif ()

if (ENABLE_HTTP_STREAM_PLAYBACK)
    if (ENABLE_LIBVLC)
        find_package(LIBVLC REQUIRED)
        macro_log_feature(LIBVLC_FOUND "libVLC" "MPD HTTP stream playback." "http://videolan.org")
        add_definitions(-DLIBVLC_FOUND)
        include_directories(${LIBVLC_INCLUDE_DIR})
        set(CANTATA_LIBS ${CANTATA_LIBS} ${LIBVLC_LIBRARY})
    else ()
        find_package(Qt5Multimedia REQUIRED)
        macro_log_feature(Qt5Multimedia_FOUND "Qt5Multimedia" "MPD HTTP stream playback." "http://qtproject.org")
        include_directories(${Qt5Multimedia_INCLUDE_DIRS})
        add_definitions(${Qt5Multimedia_DEFINITIONS})
        set(CANTATA_LIBS ${CANTATA_LIBS} ${Qt5Multimedia_LIBRARIES})
    endif ()
    set(CANTATA_SRCS ${CANTATA_SRCS} mpd-interface/httpstream.cpp)
endif ()

find_package(ZLIB REQUIRED)

if (APPLE)
    set(CANTATA_SRCS ${CANTATA_SRCS} mac/dockmenu.cpp mac/macnotify.mm)
    find_package(IOKit)
    if (IOKIT_FOUND)
        set(CANTATA_LIBS ${CANTATA_LIBS} ${IOKIT_LIBRARY})
        set(CANTATA_SRCS ${CANTATA_SRCS} mac/powermanagement.cpp)
    endif ()
    find_package(Foundation REQUIRED)
    set(CANTATA_LIBS ${CANTATA_LIBS} ${FOUNDATION_LIBRARY})

=== icons/CMakeLists.txt ===
if (NOT HAIKU)
	if (NOT WIN32 AND NOT APPLE)
	    macro (update_iconcache ICON_THEME)
	        # Update mtime of hicolor icon theme dir.
	        # We don't always have touch command (e.g. on Windows), so instead create
	        #  and delete a temporary file in the theme dir.
	        install(CODE "
	        set(DESTDIR_VALUE \"\$ENV{DESTDIR}\")
	        if (NOT DESTDIR_VALUE)
	            file(WRITE \"${CMAKE_INSTALL_PREFIX}/share/icons/${ICON_THEME}/temp.txt\" \"update\")
	            file(REMOVE \"${CMAKE_INSTALL_PREFIX}/share/icons/${ICON_THEME}/temp.txt\")
	        endif (NOT DESTDIR_VALUE)
	        ")
	    endmacro (update_iconcache)
	endif (NOT WIN32 AND NOT APPLE)
	
	if (WIN32 OR APPLE)
	    install(FILES cantata.svg DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/svg)
	    foreach (SIZE 16 22 32 48 64 128 256 512)
  	        install(FILES cantata${SIZE}.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/${SIZE} RENAME cantata.png)
  	    endforeach()
	else (WIN32 OR APPLE)
	    install(FILES cantata.svg DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/scalable/apps)
	    install(FILES cantata-symbolic.svg DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/scalable/apps)
	    foreach (SIZE 16 22 24 32 48 64 128 256 512)
	        install(FILES cantata${SIZE}.png DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/${SIZE}x${SIZE}/apps RENAME cantata.png)
        endforeach()
	endif (WIN32 OR APPLE)
	
	if (NOT WIN32 AND NOT APPLE)
	    update_iconcache(hicolor)
	
	    if (EXISTS /etc/lsb-release)
	        file(READ "/etc/lsb-release" LSB_RELEASE_CONTENTS)
	        string(REGEX MATCH "DISTRIB_ID=Ubuntu" IS_UBUNTU ${LSB_RELEASE_CONTENTS})
	        if (IS_UBUNTU)
	            set(INSTALL_UBUNTU_ICONS_DEFAULT ON)
	        else(IS_UBUNTU)
	            set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
	        endif(IS_UBUNTU)
	    else(EXISTS /etc/lsb-release)
	        set(INSTALL_UBUNTU_ICONS_DEFAULT OFF)
	    endif(EXISTS /etc/lsb-release)
	    option(INSTALL_UBUNTU_ICONS "Install the Ubuntu themed monochrome panel icons" ${INSTALL_UBUNTU_ICONS_DEFAULT})
	
	    if (INSTALL_UBUNTU_ICONS)
	        install(FILES trayicon-mono-dark.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-light/apps/22 RENAME cantata-panel.svg)
	        install(FILES trayicon-mono-light.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-dark/apps/22 RENAME cantata-panel.svg)
	        update_iconcache(ubuntu-mono-light)
	        update_iconcache(ubuntu-mono-dark)
	        add_subdirectory(suru)
	        update_iconcache(Suru)
	    endif (INSTALL_UBUNTU_ICONS)
	
	endif (NOT WIN32 AND NOT APPLE)
	
	add_subdirectory(theme)

	#if (APPLE)
	#    install(FILES trayicon-mono-dark.svg DESTINATION ${CANTATA_ICON_INSTALL_PREFIX}/scalable/apps RENAME cantata-panel.svg)
	#endif (APPLE)
endif (NOT HAIKU)

=== support/CMakeLists.txt ===
set(SUPPORT_CORE_SRCS utils.cpp thread.cpp)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${QTINCLUDES})

add_library(support-core STATIC ${SUPPORT_CORE_SRCS})
    
set (SUPPORT_SRCS icon.cpp fancytabwidget.cpp messagewidget.cpp buddylabel.cpp action.cpp actioncollection.cpp lineedit.cpp
     configuration.cpp gtkstyle.cpp spinner.cpp messagebox.cpp inputdialog.cpp thread.cpp squeezedtextlabel.cpp proxystyle.cpp
     pagewidget.cpp combobox.cpp configdialog.cpp monoicon.cpp)

if (APPLE)
    install(FILES fontawesome-webfont.ttf DESTINATION ${MACOSX_BUNDLE_RESOURCES}/fonts)
elseif (WIN32)
    install(FILES fontawesome-webfont.ttf DESTINATION ${CMAKE_INSTALL_PREFIX}/fonts)
else ()
    install(FILES fontawesome-webfont.ttf DESTINATION ${SHARE_INSTALL_PREFIX}/${CMAKE_PROJECT_NAME}/fonts)
endif ()

if (APPLE)
    set(SUPPORT_SRCS ${SUPPORT_SRCS} osxstyle.cpp flattoolbutton.cpp windowmanager.cpp)
endif ()

set(SUPPORT_SRCS ${SUPPORT_SRCS} pathrequester.cpp kmessagewidget.cpp dialog.cpp shortcutsmodel.cpp
    shortcutssettingswidget.cpp keysequencewidget.cpp acceleratormanager.cpp urllabel.cpp)
set(SUPPORT_UIS shortcutssettingswidget.ui)
 if (Qt5Gui_VERSION_MAJOR LESS 5 OR Qt5Gui_VERSION_MINOR LESS 2)
 endif ()

qt5_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
qt5_add_resources(SUPPORT_RC_SRCS ${SUPPORT_RCS})

add_library(support STATIC ${SUPPORT_SRCS} ${SUPPORT_UI_HDRS} ${SUPPORT_RC_SRCS})

=== windows/CMakeLists.txt ===
set(WINDOWS_APP_NAME Cantata)
set(WINDOWS_COMPANY_NAME Cantata)
set(WINDOWS_URL "http://${PROJECT_URL}")

if (CANTATA_SSL_LIBS)
    set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS} ${CANTATA_SSL_LIBS})
    set(CANTATA_SSL_WIN_NSIS_INSTALL "file \"libeay32.dll\"\n    file \"ssleay32.dll\"")
endif (CANTATA_SSL_LIBS)

FILE(TO_CMAKE_PATH $ENV{QTDIR} QT_DIR)
set(QT_BINARY_DIR ${QT_DIR}/bin)
set(QT_PLUGINS_DIR ${QT_DIR}/plugins)
set(QT_TRANSLATIONS_DIR ${QT_DIR}/translations)

if (ENABLE_PROXY_CONFIG)
    set(CANTATA_PROXY_ICON_INSTALL "file \"icons\\cantata\\svg\\preferences-system-network.svg\"")
else ()
    set(CANTATA_PROXY_ICON_INSTALL "")
endif ()

if (ENABLE_DEVICES_SUPPORT)
    set(CANTATA_DEVICES_ICON_INSTALL "file \"icons\\cantata\\svg\\drive-removable-media-usb-pendrive.svg\"\n    file \"icons\\cantata\\svg\\multimedia-player.svg\"")
    if (ENABLE_REMOTE_DEVICES)
        set(CANTATA_REMOTE_DEVICES_ICON_INSTALL "file \"icons\\cantata\\svg\\folder-network.svg\"\n    file \"icons\\cantata\\svg\\folder-samba.svg\"")
    else ()
        set(CANTATA_REMOTE_DEVICES_ICON_INSTALL "")
    endif ()
else ()
    set(CANTATA_DEVICES_ICON_INSTALL "")
    set(CANTATA_REMOTE_DEVICES_ICON_INSTALL "")
endif ()

configure_file(cantata.nsi.cmake ${CMAKE_CURRENT_BINARY_DIR}/cantata.nsi)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cantata.nsi cantata.ico LICENSE.txt "Cantata README.txt" "Qt License (LGPL V2).txt" "TagLib README.txt" DESTINATION ${CMAKE_INSTALL_PREFIX})

# Qt image formats...
install(FILES ${QT_PLUGINS_DIR}/imageformats/qjpeg.dll ${QT_PLUGINS_DIR}/imageformats/qsvg.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/imageformats/)

# Qt iconengines...
install(FILES ${QT_PLUGINS_DIR}/iconengines/qsvgicon.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/iconengines/)

# Qt windows platform plugin...
install(FILES ${QT_PLUGINS_DIR}/platforms/qwindows.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/platforms/)

# Qt SQL driver...
install(FILES ${QT_PLUGINS_DIR}/sqldrivers/qsqlite.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/sqldrivers/)

# Qt MultiMedia
install(FILES ${QT_PLUGINS_DIR}/mediaservice/dsengine.dll ${QT_PLUGINS_DIR}/mediaservice/qtmedia_audioengine.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/mediaservice/)

# Qt, taglib, and zlib libraries...
set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS}
    ${QT_BINARY_DIR}/Qt5Core.dll ${QT_BINARY_DIR}/Qt5Gui.dll ${QT_BINARY_DIR}/Qt5Network.dll ${QT_BINARY_DIR}/Qt5Svg.dll ${QT_BINARY_DIR}/Qt5Xml.dll
    ${QT_BINARY_DIR}/Qt5Widgets.dll ${QT_BINARY_DIR}/Qt5WinExtras.dll ${QT_BINARY_DIR}/Qt5Sql.dll
    ${QT_BINARY_DIR}/libgcc_s_dw2-1.dll ${QT_BINARY_DIR}/libstdc++-6.dll ${QT_BINARY_DIR}/libwinpthread-1.dll
    ${ZLIB_INCLUDE_DIR}/../bin/libz-1.dll ${TAGLIB_INCLUDES}/../bin/libtag.dll)

if (ENABLE_HTTP_STREAM_PLAYBACK)
    set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS} ${QT_BINARY_DIR}/Qt5Multimedia.dll)
endif()

# Qt translation files...
file(GLOB qt_trans ${QT_TRANSLATIONS_DIR}/qt_*.qm)
foreach(qm ${qt_trans})
    if (NOT ${qm} MATCHES "(${QT_TRANSLATIONS_DIR}/qt_help*)")
        list(APPEND qt_translations "${qm}")
    endif ()
endforeach()
install(FILES ${qt_translations} DESTINATION ${CMAKE_INSTALL_PREFIX}/translations/)

install(FILES ${EXTRA_WIN_LIBS} DESTINATION ${CMAKE_INSTALL_PREFIX})
install(FILES LICENSE.txt DESTINATION ${CMAKE_INSTALL_PREFIX} RENAME "Cantata License (GPL V3).txt")

=== 3rdparty/solid-lite/CMakeLists.txt ===
INCLUDE(MacroOptionalFindPackage)
INCLUDE(MacroLogFeature)

add_subdirectory( ifaces )
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}  ${QTINCLUDES})

file(MAKE_DIRECTORY
   ${CMAKE_CURRENT_BINARY_DIR}/backends/hal
   ${CMAKE_CURRENT_BINARY_DIR}/backends/udev
   ${CMAKE_CURRENT_BINARY_DIR}/backends/wmi
)

set(solidlite_LIB_SRCS
   solidnamespace.cpp
   managerbase.cpp
   device.cpp
   devicemanager.cpp
   deviceinterface.cpp
   genericinterface.cpp
   block.cpp
   storagedrive.cpp
   opticaldrive.cpp
   storagevolume.cpp
   opticaldisc.cpp
   storageaccess.cpp
   portablemediaplayer.cpp
   predicate.cpp
   predicateparse.cpp
   predicate_lexer.c
   predicate_parser.c
   xdgbasedirs.cpp

   ifaces/block.cpp
   ifaces/opticaldrive.cpp
   ifaces/device.cpp
   ifaces/deviceinterface.cpp
   ifaces/devicemanager.cpp
   ifaces/genericinterface.cpp
   ifaces/opticaldisc.cpp
   ifaces/portablemediaplayer.cpp
   ifaces/storagedrive.cpp
   ifaces/storagevolume.cpp
   ifaces/storageaccess.cpp

   backends/shared/rootdevice.cpp
)

   if (NOT WIN32 AND NOT APPLE AND WITH_SOLID_UDISKS2)
     find_package( UDev REQUIRED)
     macro_log_feature( UDEV_FOUND "UDev" "UDev support for Solid" "http://www.kernel.org/pub/linux/utils/kernel/hotplug/udev.html" FALSE "" "Allows Solid to use UDev to provide information about devices on Linux" )
   endif()
   configure_file( config-solid.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-solid.h )


   if ( UDEV_FOUND )
      message(STATUS "Building Solid UDev backend." )
      set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
      backends/udev/udevdevice.cpp
      backends/udev/udevmanager.cpp
      backends/udev/udevdeviceinterface.cpp
      backends/udev/udevgenericinterface.cpp
      backends/udev/udevportablemediaplayer.cpp
      backends/udev/udevblock.cpp
      backends/shared/udevqtclient.cpp
      backends/shared/udevqtdevice.cpp
      )

      # check for media-player-info (runtime-only optional dependency)
      set(XDG_DATA_DIRS_ENV $ENV{XDG_DATA_DIRS})  # if(ENV{..}) does not work for me
      if(XDG_DATA_DIRS_ENV)
         find_path(MEDIAPLAYERINFO_PATH sony_psp.mpi
            PATHS ENV XDG_DATA_DIRS
            PATH_SUFFIXES "media-player-info" NO_DEFAULT_PATH
         )
      else()
         set(XDG_DATA_DIRS "/usr/share")
         message(STATUS "Warning: environment variable XDG_DATA_DIRS not set, falling back to ${XDG_DATA_DIRS}")
         find_path(MEDIAPLAYERINFO_PATH sony_psp.mpi
            PATHS "${XDG_DATA_DIRS}"
            PATH_SUFFIXES "media-player-info" NO_DEFAULT_PATH
         )
      endif()

      macro_log_feature(MEDIAPLAYERINFO_PATH
         "media-player-info"
         "Enables identification and querying of portable media players"
         "http://www.freedesktop.org/wiki/Software/media-player-info"
         FALSE
         ""
         "Runtime-only dependency of the udev solid backend. Support for m-p-i is included even if not found during build"
      )
   endif( )


   message(STATUS "Building Solid HAL backend." )
   set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
   backends/hal/halblock.cpp
   backends/hal/halcdrom.cpp
   backends/hal/haldeviceinterface.cpp
   backends/hal/halfstabhandling.cpp
   backends/hal/halgenericinterface.cpp
   backends/hal/haldevice.cpp
   backends/hal/halmanager.cpp
   backends/hal/halopticaldisc.cpp
   backends/hal/halportablemediaplayer.cpp
   backends/hal/halstorageaccess.cpp
   backends/hal/halstorage.cpp
   backends/hal/halvolume.cpp
   )

    # FIXME: this should work on more Unix systems
    if (CMAKE_SYSTEM_NAME MATCHES Linux)
        if ( WITH_SOLID_UDISKS2 )
            message(STATUS "Building Solid UDisks2 backend." )
            add_definitions(-DWITH_SOLID_UDISKS2)
            set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
            backends/udisks2/udisksmanager.cpp
            backends/udisks2/udisksdevice.cpp
            backends/udisks2/udisksdevicebackend.cpp
            backends/udisks2/udisksblock.cpp
            backends/udisks2/udisksstoragevolume.cpp
            backends/udisks2/udisksdeviceinterface.cpp
            backends/udisks2/udisksopticaldisc.cpp
            backends/udisks2/udisksopticaldrive.cpp
            backends/udisks2/udisksstoragedrive.cpp
            backends/udisks2/udisksstorageaccess.cpp
            backends/udisks2/udisksgenericinterface.cpp
            backends/udisks2/dbus/manager.cpp
            )
        else ( )
            message(STATUS "Building Solid UDisks backend." )
            set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
            backends/udisks/udisksmanager.cpp
            backends/udisks/udisksdevice.cpp
            backends/udisks/udisksblock.cpp
            backends/udisks/udisksstoragevolume.cpp
            backends/udisks/udisksdeviceinterface.cpp
            backends/udisks/udisksopticaldisc.cpp
            backends/udisks/udisksopticaldrive.cpp
            backends/udisks/udisksstoragedrive.cpp
            backends/udisks/udisksstorageaccess.cpp
            backends/udisks/udisksgenericinterface.cpp
            )
        endif ( )
   endif ()

if(APPLE)
   find_package(IOKit REQUIRED)

   message(STATUS "-- Building Solid IOKit backend." )
   set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
   backends/iokit/iokitmanager.cpp
   backends/iokit/iokitdevice.cpp
   backends/iokit/cfhelper.cpp
   backends/iokit/iokitdeviceinterface.cpp
   backends/iokit/iokitgenericinterface.cpp
   )
endif(APPLE)

if(WIN32)
   include(CheckIncludeFileCXX)
   check_include_file_cxx(wbemidl.h HAVE_WBEM)
   FIND_LIBRARY(WBEM_LIBRARIES NAMES wbemuuid wbemuuidd)
   if(HAVE_WBEM AND WBEM_LIBRARIES)
      set(HAVE_WBEM True)
      message(STATUS "Found wbemuuid library: ${WBEM_LIBRARIES}")
   else()
      set(HAVE_WBEM False)
   endif()
   if(HAVE_WBEM AND NOT WINCE)
       set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_WBEM")
       message(STATUS "-- Building Solid WMI backend." )

       set(solidlite_LIB_SRCS ${solidlite_LIB_SRCS}
       backends/wmi/wmiblock.cpp
       backends/wmi/wmicdrom.cpp
       backends/wmi/wmideviceinterface.cpp
       backends/wmi/wmigenericinterface.cpp
       backends/wmi/wmidevice.cpp
       backends/wmi/wmimanager.cpp
       backends/wmi/wmiopticaldisc.cpp
       backends/wmi/wmiportablemediaplayer.cpp
       backends/wmi/wmiquery.cpp
       backends/wmi/wmistorageaccess.cpp
       backends/wmi/wmistorage.cpp
       backends/wmi/wmivolume.cpp

       )
    endif()
endif()

set(solidlite_OPTIONAL_LIBS)

if(WIN32)
   set(solidlite_OPTIONAL_LIBS ${solidlite_OPTIONAL_LIBS} ${KDEWIN_LIBRARY})
   if(HAVE_WBEM)
      set(solidlite_OPTIONAL_LIBS ${solidlite_OPTIONAL_LIBS} ${WBEM_LIBRARIES})
   endif()
endif()

if(APPLE)
   set(solidlite_OPTIONAL_LIBS ${IOKIT_LIBRARY})
endif()

add_library(solidlite ${solidlite_LIB_SRCS})

if ( UDEV_FOUND )
   set(solidlite_OPTIONAL_LIBS ${solidlite_OPTIONAL_LIBS} ${UDEV_LIBS})
endif ( )

#target_link_libraries(solidlite ${QT_QTCORE_LIBRARY} ${QT_QTDBUS_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTGUI_LIBRARY} ${solidlite_OPTIONAL_LIBS} )
target_link_libraries(solidlite ${QTLIBS} ${solidlite_OPTIONAL_LIBS})
target_link_libraries(solidlite LINK_INTERFACE_LIBRARIES ${QT_CORE_LIBRARY} )

if (WINCE)
   target_link_libraries(solidlite ${WCECOMPAT_LIBRARIES})
endif()

# set_target_properties(solidlite PROPERTIES
#    VERSION ${GENERIC_LIB_VERSION}
#    SOVERSION ${GENERIC_LIB_SOVERSION}
# )

#set(lexer_FILE predicate_lexer)
#set(parser_FILE predicate_parser)

#find_package(Flex)
#macro_log_feature(FLEX_FOUND
#   "Flex"
#   "Allows the Solid predicate parser to be updated"
#   "http://flex.sourceforge.net"
#   FALSE
#   ""
#   "Required by the UpdateSolidPredicateParser target (mainly useful for developers)")

#find_program(BISON_EXECUTABLE bison)
#macro_log_feature(BISON_EXECUTABLE
#   "Bison"
#   "Allows the Solid predicate parser to be updated"
#   "http://www.gnu.org/software/bison"
#   FALSE
#   ""
#   "Required by the UpdateSolidPredicateParser target (mainly useful for developers)")
#mark_as_advanced(BISON_EXECUTABLE)      # don't show it in the simple view in cmake-gui/ccmake

# if (FLEX_EXECUTABLE AND BISON_EXECUTABLE)
#
#    add_custom_target(UpdateSolidPredicateParser
#                      COMMAND ${FLEX_EXECUTABLE} -P Solid -o${lexer_FILE}.c ${lexer_FILE}.l
#                      COMMAND ${BISON_EXECUTABLE} -p Solid -d -b ${parser_FILE} ${parser_FILE}.y
#                      COMMAND ${CMAKE_COMMAND} -E copy ${parser_FILE}.tab.c ${CMAKE_CURRENT_SOURCE_DIR}/${parser_FILE}.c
#                      COMMAND ${CMAKE_COMMAND} -E copy ${parser_FILE}.tab.h ${CMAKE_CURRENT_SOURCE_DIR}/${parser_FILE}.h
#                      COMMAND ${CMAKE_COMMAND} -E remove ${parser_FILE}.tab.c ${parser_FILE}.tab.h
#                      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
#
# else (FLEX_EXECUTABLE AND BISON_EXECUTABLE)
#    add_custom_target(UpdateSolidPredicateParser
#                      COMMAND echo "flex and/or bison not found, so target UpdateSolidPredicateParser inactive")
# endif (FLEX_EXECUTABLE AND BISON_EXECUTABLE)

=== devices/avahi/CMakeLists.txt ===
set(AVAHI_SRCS avahi.cpp avahiservice.cpp)

qt5_add_dbus_interfaces(AVAHI_SRCS org.freedesktop.Avahi.Server.xml )
qt5_add_dbus_interfaces(AVAHI_SRCS org.freedesktop.Avahi.ServiceBrowser.xml)
qt5_add_dbus_interfaces(AVAHI_SRCS org.freedesktop.Avahi.ServiceResolver.xml)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${QTINCLUDES})
add_library(avahi STATIC ${AVAHI_SRCS})

=== devices/mounter/CMakeLists.txt ===
set(CANTATA_MOUNTER_SRCS main.cpp mounter.cpp)
qt5_add_dbus_adaptor(CANTATA_MOUNTER_SRCS mpd.cantata.mounter.xml mounter.h Mounter )

add_executable( cantata-mounter ${CANTATA_MOUNTER_SRCS} )
install(TARGETS cantata-mounter RUNTIME DESTINATION lib/cantata)
configure_file(mpd.cantata.mounter.service.cmake ${CMAKE_CURRENT_BINARY_DIR}/mpd.cantata.mounter.service)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mpd.cantata.mounter.service DESTINATION ${SHARE_INSTALL_PREFIX}/dbus-1/system-services/ )
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/mpd.cantata.mounter.conf DESTINATION /etc/dbus-1/system.d/ )

target_link_libraries(cantata-mounter ${Qt5Core_LIBRARIES} ${Qt5DBus_LIBRARIES})
include_directories( ${QTINCLUDES} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR})

install(FILES ${_qmFile} DESTINATION ${SHARE_INSTALL_PREFIX}/cantata/)
install(PROGRAMS mount.cifs.wrapper DESTINATION ${SHARE_INSTALL_PREFIX}/cantata/scripts/ )

=== icons/suru/CMakeLists.txt ===
set(CANTATA_SURU_ICON_INSTALL_PREFIX ${SHARE_INSTALL_PREFIX}/icons/Suru)

install(FILES ../cantata-symbolic.svg DESTINATION ${CANTATA_SURU_ICON_INSTALL_PREFIX}/scalable/apps)
foreach (SIZE 16 24 32 48 256)
    foreach (DPI "" @2x)
        install(FILES cantata-${SIZE}x${SIZE}${DPI}.png DESTINATION ${CANTATA_SURU_ICON_INSTALL_PREFIX}/${SIZE}x${SIZE}${DPI}/apps RENAME cantata.png)
    endforeach()
endforeach()

=== icons/theme/CMakeLists.txt ===
set(ICON_FILES
svg/audio-x-generic.svg
svg/information.svg
svg/folder-temp.svg
svg/fork.svg
svg/inode-directory.svg
svg/network-server-database.svg
svg/preferences-desktop-keyboard.svg
svg/preferences-other.svg
svg/speaker.svg
svg/key.svg
svg64/dialog-error.svg
svg64/dialog-information.svg
svg64/dialog-question.svg
svg64/dialog-warning.svg
)

if (ENABLE_PROXY_CONFIG)
    set(ICON_FILES svg/preferences-system-network.svg ${ICON_FILES})
endif (ENABLE_PROXY_CONFIG)

if (ENABLE_DEVICES_SUPPORT)
    set(ICON_FILES svg/drive-removable-media-usb-pendrive.svg svg/multimedia-player.svg ${ICON_FILES})
    if (ENABLE_REMOTE_DEVICES)
        set(ICON_FILES svg/folder-network.svg svg/folder-samba.svg ${ICON_FILES})
    endif (ENABLE_REMOTE_DEVICES)
endif (ENABLE_DEVICES_SUPPORT)

if (WIN32 OR APPLE)
    set(CANTATA_ICON_THEME_PATH ${CANTATA_ICON_INSTALL_PREFIX})
else (WIN32 OR APPLE)
    set(CANTATA_ICON_THEME_PATH ${SHARE_INSTALL_PREFIX}/${CMAKE_PROJECT_NAME}/icons/cantata)
endif (WIN32 OR APPLE)

foreach(ICON ${ICON_FILES})
    get_filename_component(ICON_PATH ${ICON} PATH)
    install(FILES ${ICON} DESTINATION ${CANTATA_ICON_THEME_PATH}/${ICON_PATH})
endforeach(ICON ${ICON_FILES})
install(FILES AUTHORS index.theme LICENSE DESTINATION ${CANTATA_ICON_THEME_PATH})

install(FILES ../cantata128.png DESTINATION ${CANTATA_ICON_THEME_PATH}/128 RENAME cantata.png)
if (NOT WIN32 AND NOT APPLE)
    install(FILES ../cantata.svg DESTINATION ${CANTATA_ICON_THEME_PATH}/svg)
endif (NOT WIN32 AND NOT APPLE)

=== debian/changelog ===
cantata (2.3.0.ds1-2build1) cosmic; urgency=medium

  * No-change rebuild for ffmpeg soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Jul 2018 08:46:20 +0000

cantata (2.3.0.ds1-2) unstable; urgency=high

  * Disable cantata-mounter (Closes: #901798).

 -- Stuart Prescott <stuart@debian.org>  Tue, 19 Jun 2018 11:38:16 +1000

cantata (2.3.0.ds1-1) unstable; urgency=medium

  * New upstream version
    - Refresh patches.
    - Builds with FFmpeg 4.0" (Closes: #888363).
    - Fixes system tray in XFCE (Closes: #891774).
    - Fix dynamic playlists on IPv6 (Closes: #885085).
    - Update dependenct to libio-socket-ip-perl.
  * Add copyright hints for cme to manage d/copyright.
  * Update Standards-Version to 4.1.4 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Tue, 01 May 2018 14:54:54 +1000

cantata (2.2.0.ds1-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Stuart Prescott ]
  * Add additional dependency for new perl scripts
  * Add terminal commas for smaller future diffs
  * Switch build-depends to libcddb2-dev (Closes: #894544)
  * Update Standards-Version to 4.1.3 (no changes required)
  * Update team email address to debian-multimedia@lists.debian.org

 -- Stuart Prescott <stuart@debian.org>  Tue, 03 Apr 2018 11:19:43 +1000

=== debian/control ===
Source: cantata
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Stuart Prescott <stuart@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 11~),
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libcddb2-dev,
 libcdparanoia-dev,
 libebur128-dev,
 libmpg123-dev,
 libmtp-dev (>= 1.0.0),
 libmusicbrainz5-dev (>= 5.1.0+git20150707),
 libphonon4qt5-dev,
 libqt5svg5-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libtag-extras-dev,
 libtag1-dev,
 libudev-dev,
 libvlc-dev,
 libvlccore-dev,
 libx11-dev,
 pkg-config,
 pkg-kde-tools,
 qtbase5-dev,
 qtmultimedia5-dev,
 qttools5-dev-tools,
Standards-Version: 4.1.4
Homepage: https://github.com/CDrummond/cantata
Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git

Package: cantata
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 fonts-font-awesome,
 libqt5sql5-sqlite,
Recommends:
 liburi-perl,
 libio-socket-ip-perl,
Provides:
 mpd-client,
Suggests:
 media-player-info,
 mpd,
Description: Qt client for the music player daemon (MPD)
 Cantata is a graphical front-end for the music player daemon, MPD. It provides
 many tools to view and manage the music collection including:
 .
   * library - sorted by album, artist, track, directory
   * albums with cover art
   * user defined playlists
   * dynamic playlists
   * streams, internet radio
   * lyrics
   * artist information from Wikipedia
   * device support for USB mass storage, MTP and CDs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=5

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_REMOTE_DEVICES=OFF

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/cantata/usr/share/cantata/icons/cantata/LICENSE

override_dh_installexamples:
	dh_installexamples
	chmod -x $(CURDIR)/debian/cantata/usr/share/doc/cantata/examples/cantata-dynamic.service

## cantata 2.3.2.ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 PROJECT(cantata)
 
-#  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, and README will need updating.
-#        dbus/mpd.cantata.xml and devices/mounter/mpd.cantata.mounter.xml will also need renaming/updating.
+#  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, README, and
+#        dbus/mpd.cantata.xml will need renaming/updating.
 set(PROJECT_URL "cantata.mpd")
 set(PROJECT_REV_URL "mpd.cantata")
 
@@ -24,11 +24,12 @@
 
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
 set(CPACK_GENERATOR "DEB;RPM;TBZ2")
-set(DEBIAN_PACKAGE_DESCRIPTION "Qt Client for MPD")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Qt Client for MPD")
 set(CPACK_SOURCE_GENERATOR "TBZ2")
 set(CPACK_PACKAGE_VERSION_MAJOR "2")
 set(CPACK_PACKAGE_VERSION_MINOR "3")
-set(CPACK_PACKAGE_VERSION_PATCH "0")
+set(CPACK_PACKAGE_VERSION_PATCH "2")
+set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
 set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
 set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
 set(CANTATA_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
@@ -44,17 +45,17 @@
 option(ENABLE_HTTP_STREAM_PLAYBACK "Enable playback of MPD HTTP streams (LibVLC or QtMultimedia)" ON)
 option(ENABLE_FFMPEG "Enable ffmpeg/libav libraries (required for replaygain calculation)" ON)
 option(ENABLE_MPG123 "Enable mpg123 libraries (required for replaygain calculation)" ON)
-option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" OFF)
+option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" ON)
 option(ENABLE_HTTP_SERVER "Enable internal HTTP server to play non-MPD files" ON)
+option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
+
 if (WIN32 OR APPLE OR HAIKU)
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
-    option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
 else ()
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
     option(ENABLE_REMOTE_DEVICES "Enable support for remote (sshfs, samba) devices" ON)
     option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" ON)
     option(ENABLE_SIMPLE_MPD_SUPPORT "Enable support for simple (Cantata controlled) MPD" ON)
-    option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" ON)
 endif ()
 option(ENABLE_CDPARANOIA "Enable CDParanoia libraries (this or libCDIO_paranoia required for AudioCD support)" ON)
 option(ENABLE_CDIOPARANOIA "Enable libCDIO_paranoia libraries (this or CDParanoia required for AudioCD support)" ON)
@@ -62,6 +63,11 @@
 option(ENABLE_MUSICBRAINZ "Enable MusicBrianz libraries (either this or CDDB required for AudioCD support)" ON)
 option(ENABLE_MTP "Enable MTP library (required to support MTP devices)" ON)
 option(ENABLE_AVAHI "Enable automatic mpd server discovery" ${UNIX})
+
+# Build all apps into top-level folder, so that can run dev versions without install
+if (NOT WIN32 AND NOT APPLE)
+    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
+endif()
 
 if(ENABLE_AVAHI)
     find_package(Avahi)
@@ -268,4 +274,3 @@
         set(CANTATA_SRCS ${CANTATA_SRCS} mac/powermanagement.cpp)
     endif ()
     find_package(Foundation REQUIRED)
-    set(CANTATA_LIBS ${CANTATA_LIBS} ${FOUNDATION_LIBRARY})

=== debian/changelog ===
cantata (2.3.2.ds1-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Thu, 04 Oct 2018 01:42:10 +1000

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
  qtbase5-dev,
  qtmultimedia5-dev,
  qttools5-dev-tools,
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://github.com/CDrummond/cantata
 Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
 Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git

## cantata 2.3.3.ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 set(CPACK_SOURCE_GENERATOR "TBZ2")
 set(CPACK_PACKAGE_VERSION_MAJOR "2")
 set(CPACK_PACKAGE_VERSION_MINOR "3")
-set(CPACK_PACKAGE_VERSION_PATCH "2")
+set(CPACK_PACKAGE_VERSION_PATCH "3")
 set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
 set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
 set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
@@ -37,7 +37,7 @@
 set(CANTATA_VERSION_WITH_SPIN "${CANTATA_VERSION_FULL}${CPACK_PACKAGE_VERSION_SPIN}")
 set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
 set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
-set(CPACK_SOURCE_IGNORE_FILES  "/.svn/;/.git/;.gitignore;.project;CMakeLists.txt.user;README.md;/screenshots/")
+set(CPACK_SOURCE_IGNORE_FILES  "/.svn/;/.git/;.gitignore;.github/;.project;CMakeLists.txt.user;README.md;/screenshots/")
 include(CPack)
 include(MacroLogFeature)

=== translations/CMakeLists.txt ===
file(GLOB TS_FILES cantata_*.ts)
foreach (TS_FILE ${TS_FILES})
    get_filename_component(TRANS ${TS_FILE} NAME_WE)
    list(APPEND CANTATA_TRANS "${TRANS}")
endforeach ()

find_program(LRELEASE_EXECUTABLE lrelease)

if (LRELEASE_EXECUTABLE)
    set(catalogname cantata)
    add_custom_target(translations ALL)
    foreach(TRANS ${CANTATA_TRANS})
        if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
            set(CUR_TS_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
            set(CUR_QM_FILE ${CMAKE_CURRENT_BINARY_DIR}/${TRANS}.qm)
            add_custom_command(TARGET translations
                COMMAND ${LRELEASE_EXECUTABLE} ARGS ${CUR_TS_FILE} -qm ${CUR_QM_FILE}
                DEPENDS ${CUR_TS_FILE})
            if (WIN32)
                install(FILES ${CUR_QM_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX}/translations/)
            elseif (APPLE)
                install(FILES ${CUR_QM_FILE} DESTINATION ${MACOSX_BUNDLE_RESOURCES}/translations/)
            else ()
                install(FILES ${CUR_QM_FILE} DESTINATION ${SHARE_INSTALL_PREFIX}/cantata/translations/)
            endif ()
        endif ()
    endforeach()
else ()
    message("------\n"
            "NOTE: lrelease not found. Translations will *not* be installed\n"
            "------\n")
endif ()

=== debian/changelog ===
cantata (2.3.3.ds1-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Drop to debhelper 10 compat to ease backports.
  * Disable automatic dbgsym packages.
  * Enable ENABLE_HTTP_STREAM_PLAYBACK.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 04 Feb 2019 13:30:22 -0800

cantata (2.3.3.ds1-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.3.0 (no changes required).

 -- Stuart Prescott <stuart@debian.org>  Mon, 31 Dec 2018 16:13:32 +1100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: cantata
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Stuart Prescott <stuart@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 11~),
+ debhelper (>= 10.2),
  libavcodec-dev,
  libavformat-dev,
  libavutil-dev,
@@ -31,7 +32,7 @@
  qtbase5-dev,
  qtmultimedia5-dev,
  qttools5-dev-tools,
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/CDrummond/cantata
 Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
 Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git
@@ -43,7 +44,6 @@
  ${shlibs:Depends},
  fonts-font-awesome,
  libqt5sql5-sqlite,
-Recommends:
  liburi-perl,
  libio-socket-ip-perl,
 Provides:

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=5

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_REMOTE_DEVICES=OFF \
                         -DENABLE_HTTP_STREAM_PLAYBACK=ON

override_dh_installexamples:
	dh_installexamples
	chmod -x $(CURDIR)/debian/cantata/usr/share/doc/cantata/examples/cantata-dynamic.service

override_dh_strip:
	dh_strip --no-automatic-dbgsym
